<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>NANO102/112 BSP: StdDriver/src/retarget.c File Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../M0Banner_v2.jpg"/></td>
  <td id="projectalign">
   <div id="projectname">NANO102/112 BSP<span id="projectnumber">&#160;V3.04.000</span>
   </div>
   <div id="projectbrief">The Board Support Package for Nano102/112 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',false,false,'search.php','Search');
});
/* @license-end */
</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="../../dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="../../dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Data Structures</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle"><div class="title">retarget.c File Reference</div></div>
</div><!--header-->
<div class="contents">

<p>Nano 102/112 series retarget source file.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;stdio.h&gt;</code><br />
<code>#include &quot;<a class="el" href="../../da/d91/_nano1_x2_series_8h_source.html">Nano1X2Series.h</a>&quot;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for retarget.c:</div>
<div class="dyncontent">
<div class="center"><img src="../../d2/d0d/retarget_8c__incl.png" border="0" usemap="#a_std_driver_2src_2retarget_8c" alt=""/></div>
</div>
</div>
<p><a href="../../d3/d3d/retarget_8c_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="nested-classes" name="nested-classes"></a>
Data Structures</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../da/d3e/struct_____f_i_l_e.html">__FILE</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="define-members" name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ad7725bd9f76ca4bbdfdeb470ac223138"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#ad7725bd9f76ca4bbdfdeb470ac223138">DEBUG_PORT</a>&#160;&#160;&#160;<a class="el" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga0508661f121639ffdee7de2353a0def2">UART0</a></td></tr>
<tr class="separator:ad7725bd9f76ca4bbdfdeb470ac223138"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6821bafc3c88dfb2e433a095df9940c6"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a6821bafc3c88dfb2e433a095df9940c6">BUF_SIZE</a>&#160;&#160;&#160;512</td></tr>
<tr class="separator:a6821bafc3c88dfb2e433a095df9940c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac607bf387b29162be6a9b77fc7999539"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">__WEAK</a>&#160;&#160;&#160;<a class="el" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a>((weak))</td></tr>
<tr class="memdesc:ac607bf387b29162be6a9b77fc7999539"><td class="mdescLeft">&#160;</td><td class="mdescRight">Routine to send a char.  <a href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">More...</a><br /></td></tr>
<tr class="separator:ac607bf387b29162be6a9b77fc7999539"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="enum-members" name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:adc29c2ff13d900c2f185ee95427fb06c"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom">{ <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca20eb91018c3024df2ae3582f6e8e662c">r0</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca9e5d4ad994db934322c89e4dbef3f7ce">r1</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca22827a377de213db078757f368a86b05">r2</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca5d5f095a80fd85c2eb082cf401ea61bd">r3</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06cab85e19a5be81ee4c3b2e1a7f1081b01a">r12</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719">lr</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06ca0d008574886a382d46ba2616c506af41">pc</a>
, <br />
&#160;&#160;<a class="el" href="../../d3/d3d/retarget_8c.html#adc29c2ff13d900c2f185ee95427fb06cafd586543cfec6b0f210fe63e60296dcd">psr</a>
<br />
 }</td></tr>
<tr class="separator:adc29c2ff13d900c2f185ee95427fb06c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="func-members" name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a97e9b1fe8d4c010474637a654aad6566"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a97e9b1fe8d4c010474637a654aad6566">kbhit</a> (void)</td></tr>
<tr class="memdesc:a97e9b1fe8d4c010474637a654aad6566"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check any char input from UART.  <a href="../../d3/d3d/retarget_8c.html#a97e9b1fe8d4c010474637a654aad6566">More...</a><br /></td></tr>
<tr class="separator:a97e9b1fe8d4c010474637a654aad6566"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a6e4a05dd526dca0c0432dc738a7a02"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">IsDebugFifoEmpty</a> (void)</td></tr>
<tr class="memdesc:a5a6e4a05dd526dca0c0432dc738a7a02"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check if debug message finished.  <a href="../../d3/d3d/retarget_8c.html#a5a6e4a05dd526dca0c0432dc738a7a02">More...</a><br /></td></tr>
<tr class="separator:a5a6e4a05dd526dca0c0432dc738a7a02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1647e9479b4be5731d79c81af76826c5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a1647e9479b4be5731d79c81af76826c5">_ttywrch</a> (int ch)</td></tr>
<tr class="memdesc:a1647e9479b4be5731d79c81af76826c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">C library retargetting.  <a href="../../d3/d3d/retarget_8c.html#a1647e9479b4be5731d79c81af76826c5">More...</a><br /></td></tr>
<tr class="separator:a1647e9479b4be5731d79c81af76826c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a32d2b4f69d4059618d9c49a894523cfa"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a32d2b4f69d4059618d9c49a894523cfa">fputc</a> (int ch, FILE *stream)</td></tr>
<tr class="memdesc:a32d2b4f69d4059618d9c49a894523cfa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Write character to stream.  <a href="../../d3/d3d/retarget_8c.html#a32d2b4f69d4059618d9c49a894523cfa">More...</a><br /></td></tr>
<tr class="separator:a32d2b4f69d4059618d9c49a894523cfa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad71fc5c80d56f83994f96dc83d0bbabe"><td class="memItemLeft" align="right" valign="top">char&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">GetChar</a> (void)</td></tr>
<tr class="memdesc:ad71fc5c80d56f83994f96dc83d0bbabe"><td class="mdescLeft">&#160;</td><td class="mdescRight">Routine to get a char.  <a href="../../d3/d3d/retarget_8c.html#ad71fc5c80d56f83994f96dc83d0bbabe">More...</a><br /></td></tr>
<tr class="separator:ad71fc5c80d56f83994f96dc83d0bbabe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6810d0fa478aa8204d73d9fc5d026c64"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">SendChar_ToUART</a> (int ch)</td></tr>
<tr class="memdesc:a6810d0fa478aa8204d73d9fc5d026c64"><td class="mdescLeft">&#160;</td><td class="mdescRight">Routine to send a char.  <a href="../../d3/d3d/retarget_8c.html#a6810d0fa478aa8204d73d9fc5d026c64">More...</a><br /></td></tr>
<tr class="separator:a6810d0fa478aa8204d73d9fc5d026c64"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a49be7df965b3acf68e2c5c82d6869ab6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a49be7df965b3acf68e2c5c82d6869ab6">SendChar</a> (int ch)</td></tr>
<tr class="separator:a49be7df965b3acf68e2c5c82d6869ab6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a099c43ad08420cc1950b5958939dbb0b"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a099c43ad08420cc1950b5958939dbb0b">DumpStack</a> (uint32_t stack[])</td></tr>
<tr class="memdesc:a099c43ad08420cc1950b5958939dbb0b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Helper function to dump register while hard fault occurred.  <a href="../../d3/d3d/retarget_8c.html#a099c43ad08420cc1950b5958939dbb0b">More...</a><br /></td></tr>
<tr class="separator:a099c43ad08420cc1950b5958939dbb0b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a9d8f093940fa3017cf1d9337ce5f25"><td class="memItemLeft" align="right" valign="top">int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a0a9d8f093940fa3017cf1d9337ce5f25">SH_Return</a> (int32_t n32In_R0, int32_t n32In_R1, int32_t *pn32Out_R0)</td></tr>
<tr class="separator:a0a9d8f093940fa3017cf1d9337ce5f25"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf94add8ada1485e9cedbf027acebfa00"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a> ((weak))</td></tr>
<tr class="memdesc:gaf94add8ada1485e9cedbf027acebfa00"><td class="mdescLeft">&#160;</td><td class="mdescRight">A callback called by library while smartcard request for a time extension.  <a href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">More...</a><br /></td></tr>
<tr class="separator:gaf94add8ada1485e9cedbf027acebfa00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab11a990e4f8863a1e7736e3c1d430092"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#ab11a990e4f8863a1e7736e3c1d430092">fgetc</a> (FILE *stream)</td></tr>
<tr class="memdesc:ab11a990e4f8863a1e7736e3c1d430092"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get character from UART debug port or semihosting input.  <a href="../../d3/d3d/retarget_8c.html#ab11a990e4f8863a1e7736e3c1d430092">More...</a><br /></td></tr>
<tr class="separator:ab11a990e4f8863a1e7736e3c1d430092"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4a98383bb54291c2abede7aa28acf597"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#a4a98383bb54291c2abede7aa28acf597">ferror</a> (FILE *stream)</td></tr>
<tr class="memdesc:a4a98383bb54291c2abede7aa28acf597"><td class="mdescLeft">&#160;</td><td class="mdescRight">Check error indicator.  <a href="../../d3/d3d/retarget_8c.html#a4a98383bb54291c2abede7aa28acf597">More...</a><br /></td></tr>
<tr class="separator:a4a98383bb54291c2abede7aa28acf597"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="var-members" name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:ac1f65ebf7d6f28fb49530ee0095306cb"><td class="memItemLeft" align="right" valign="top">FILE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#ac1f65ebf7d6f28fb49530ee0095306cb">__stdout</a></td></tr>
<tr class="separator:ac1f65ebf7d6f28fb49530ee0095306cb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abb2a819d3c88269eba04ea62d759bef5"><td class="memItemLeft" align="right" valign="top">FILE&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#abb2a819d3c88269eba04ea62d759bef5">__stdin</a></td></tr>
<tr class="separator:abb2a819d3c88269eba04ea62d759bef5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1f65f8ccc2d14501465115086e9c761"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="../../d5/d32/semihosting_8h.html#a8e2aaf30f82842a5290bcfe6f6848dc3">volatile</a> int32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d3/d3d/retarget_8c.html#af1f65f8ccc2d14501465115086e9c761">g_ICE_Conneced</a> = 1</td></tr>
<tr class="separator:af1f65f8ccc2d14501465115086e9c761"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p >Nano 102/112 series retarget source file. </p>
<dl class="section version"><dt>Version</dt><dd>V2.00</dd></dl>
<dl class="section note"><dt>Note</dt><dd>SPDX-License-Identifier: Apache-2.0 Copyright (C) 2024 Nuvoton Technology Corp. All rights reserved. </dd></dl>

<p class="definition">Definition in file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
</div><h2 class="groupheader">Macro Definition Documentation</h2>
<a id="ac607bf387b29162be6a9b77fc7999539" name="ac607bf387b29162be6a9b77fc7999539"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac607bf387b29162be6a9b77fc7999539">&#9670;&nbsp;</a></span>__WEAK</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define __WEAK&#160;&#160;&#160;<a class="el" href="../../d3/d0c/group___n_a_n_o100___s_c_l_i_b___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gaf94add8ada1485e9cedbf027acebfa00">__attribute__</a>((weak))</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Routine to send a char. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ch</td><td>: A character data writes to debug port</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Send value from UART debug port or semihost</dd></dl>
<p>Send a target char to UART debug port or semihost. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00350">350</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="a6821bafc3c88dfb2e433a095df9940c6" name="a6821bafc3c88dfb2e433a095df9940c6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6821bafc3c88dfb2e433a095df9940c6">&#9670;&nbsp;</a></span>BUF_SIZE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define BUF_SIZE&#160;&#160;&#160;512</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00030">30</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="ad7725bd9f76ca4bbdfdeb470ac223138" name="ad7725bd9f76ca4bbdfdeb470ac223138"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad7725bd9f76ca4bbdfdeb470ac223138">&#9670;&nbsp;</a></span>DEBUG_PORT</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define DEBUG_PORT&#160;&#160;&#160;<a class="el" href="../../da/d2d/group___n_a_n_o1_x2___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga0508661f121639ffdee7de2353a0def2">UART0</a></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00028">28</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="adc29c2ff13d900c2f185ee95427fb06c" name="adc29c2ff13d900c2f185ee95427fb06c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adc29c2ff13d900c2f185ee95427fb06c">&#9670;&nbsp;</a></span>anonymous enum</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">anonymous enum</td>
        </tr>
      </table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06ca20eb91018c3024df2ae3582f6e8e662c" name="adc29c2ff13d900c2f185ee95427fb06ca20eb91018c3024df2ae3582f6e8e662c"></a>r0&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06ca9e5d4ad994db934322c89e4dbef3f7ce" name="adc29c2ff13d900c2f185ee95427fb06ca9e5d4ad994db934322c89e4dbef3f7ce"></a>r1&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06ca22827a377de213db078757f368a86b05" name="adc29c2ff13d900c2f185ee95427fb06ca22827a377de213db078757f368a86b05"></a>r2&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06ca5d5f095a80fd85c2eb082cf401ea61bd" name="adc29c2ff13d900c2f185ee95427fb06ca5d5f095a80fd85c2eb082cf401ea61bd"></a>r3&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06cab85e19a5be81ee4c3b2e1a7f1081b01a" name="adc29c2ff13d900c2f185ee95427fb06cab85e19a5be81ee4c3b2e1a7f1081b01a"></a>r12&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719" name="adc29c2ff13d900c2f185ee95427fb06ca29995ab8070d8bcd4b81920f486d8719"></a>lr&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06ca0d008574886a382d46ba2616c506af41" name="adc29c2ff13d900c2f185ee95427fb06ca0d008574886a382d46ba2616c506af41"></a>pc&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="adc29c2ff13d900c2f185ee95427fb06cafd586543cfec6b0f210fe63e60296dcd" name="adc29c2ff13d900c2f185ee95427fb06cafd586543cfec6b0f210fe63e60296dcd"></a>psr&#160;</td><td class="fielddoc"></td></tr>
</table>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00094">94</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a1647e9479b4be5731d79c81af76826c5" name="a1647e9479b4be5731d79c81af76826c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1647e9479b4be5731d79c81af76826c5">&#9670;&nbsp;</a></span>_ttywrch()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void _ttywrch </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ch</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>C library retargetting. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ch</td><td>Write a character data</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None</dd></dl>
<p>Check if message finished (FIFO empty of debug port) </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00503">503</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_a1647e9479b4be5731d79c81af76826c5_cgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_a1647e9479b4be5731d79c81af76826c5_cgraph" alt=""/></div>
</div>

</div>
</div>
<a id="a099c43ad08420cc1950b5958939dbb0b" name="a099c43ad08420cc1950b5958939dbb0b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a099c43ad08420cc1950b5958939dbb0b">&#9670;&nbsp;</a></span>DumpStack()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void DumpStack </td>
          <td>(</td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>stack</em>[]</td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Helper function to dump register while hard fault occurred. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">stack</td><td>pointer points to the dumped registers in SRAM </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>None</dd></dl>
<p>This function is implement to print r0, r1, r2, r3, r12, lr, pc, psr </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00103">103</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_a099c43ad08420cc1950b5958939dbb0b_icgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_a099c43ad08420cc1950b5958939dbb0b_icgraph" alt=""/></div>
</div>

</div>
</div>
<a id="a4a98383bb54291c2abede7aa28acf597" name="a4a98383bb54291c2abede7aa28acf597"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4a98383bb54291c2abede7aa28acf597">&#9670;&nbsp;</a></span>ferror()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int ferror </td>
          <td>(</td>
          <td class="paramtype">FILE *&#160;</td>
          <td class="paramname"><em>stream</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check error indicator. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">stream</td><td>Pointer to a FILE object that identifies the stream.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>If the error indicator associated with the stream was set, the function returns a nonzero value. Otherwise, it returns a zero value.</dd></dl>
<p>Checks if the error indicator associated with stream is set, returning a value different from zero if it is. This indicator is generally set by a previous operation on the stream that failed.</p>
<dl class="section note"><dt>Note</dt><dd>The above descriptions are copied from <a href="http://www.cplusplus.com/reference/clibrary/cstdio/ferror/">http://www.cplusplus.com/reference/clibrary/cstdio/ferror/</a>. </dd></dl>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00603">603</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="ab11a990e4f8863a1e7736e3c1d430092" name="ab11a990e4f8863a1e7736e3c1d430092"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab11a990e4f8863a1e7736e3c1d430092">&#9670;&nbsp;</a></span>fgetc()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fgetc </td>
          <td>(</td>
          <td class="paramtype">FILE *&#160;</td>
          <td class="paramname"><em>stream</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Get character from UART debug port or semihosting input. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">stream</td><td>Pointer to a FILE object that identifies the stream on which the operation is to be performed.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The character read from UART debug port or semihosting</dd></dl>
<p>For get message from debug port or semihosting. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00583">583</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_ab11a990e4f8863a1e7736e3c1d430092_cgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_ab11a990e4f8863a1e7736e3c1d430092_cgraph" alt=""/></div>
</div>

</div>
</div>
<a id="a32d2b4f69d4059618d9c49a894523cfa" name="a32d2b4f69d4059618d9c49a894523cfa"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a32d2b4f69d4059618d9c49a894523cfa">&#9670;&nbsp;</a></span>fputc()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fputc </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ch</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">FILE *&#160;</td>
          <td class="paramname"><em>stream</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Write character to stream. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ch</td><td>Character to be written. The character is passed as its int promotion. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">stream</td><td>Pointer to a FILE object that identifies the stream where the character is to be written.</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>If there are no errors, the same character that has been written is returned. If an error occurs, EOF is returned and the error indicator is set (see ferror).</dd></dl>
<p>Writes a character to the stream and advances the position indicator.<br  />
 The character is written at the current position of the stream as indicated <br  />
 by the internal position indicator, which is then advanced one character.</p>
<dl class="section note"><dt>Note</dt><dd>The above descriptions are copied from <a href="http://www.cplusplus.com/reference/clibrary/cstdio/fputc/">http://www.cplusplus.com/reference/clibrary/cstdio/fputc/</a>. </dd></dl>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00527">527</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_a32d2b4f69d4059618d9c49a894523cfa_cgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_a32d2b4f69d4059618d9c49a894523cfa_cgraph" alt=""/></div>
</div>

</div>
</div>
<a id="ad71fc5c80d56f83994f96dc83d0bbabe" name="ad71fc5c80d56f83994f96dc83d0bbabe"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad71fc5c80d56f83994f96dc83d0bbabe">&#9670;&nbsp;</a></span>GetChar()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char GetChar </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Routine to get a char. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Get value from UART debug port or semihost</dd></dl>
<p>Wait UART debug port or semihost to input a char. </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00399">399</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_ad71fc5c80d56f83994f96dc83d0bbabe_icgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_ad71fc5c80d56f83994f96dc83d0bbabe_icgraph" alt=""/></div>
</div>

</div>
</div>
<a id="a5a6e4a05dd526dca0c0432dc738a7a02" name="a5a6e4a05dd526dca0c0432dc738a7a02"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5a6e4a05dd526dca0c0432dc738a7a02">&#9670;&nbsp;</a></span>IsDebugFifoEmpty()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int IsDebugFifoEmpty </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check if debug message finished. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">1</td><td>Message is finished </td></tr>
    <tr><td class="paramname">0</td><td>Message is transmitting.</td></tr>
  </table>
  </dd>
</dl>
<p>Check if message finished (FIFO empty of debug port) </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00488">488</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="a97e9b1fe8d4c010474637a654aad6566" name="a97e9b1fe8d4c010474637a654aad6566"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a97e9b1fe8d4c010474637a654aad6566">&#9670;&nbsp;</a></span>kbhit()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int kbhit </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Check any char input from UART. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">1</td><td>No any char input </td></tr>
    <tr><td class="paramname">0</td><td>Have some char input</td></tr>
  </table>
  </dd>
</dl>
<p>Check UART RSR RX EMPTY or not to determine if any char input from UART </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00472">472</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="a49be7df965b3acf68e2c5c82d6869ab6" name="a49be7df965b3acf68e2c5c82d6869ab6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a49be7df965b3acf68e2c5c82d6869ab6">&#9670;&nbsp;</a></span>SendChar()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d3/d3d/retarget_8c.html#ac607bf387b29162be6a9b77fc7999539">__WEAK</a> void SendChar </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ch</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00352">352</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the call graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_a49be7df965b3acf68e2c5c82d6869ab6_cgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_a49be7df965b3acf68e2c5c82d6869ab6_cgraph" alt=""/></div>
</div>
<div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_a49be7df965b3acf68e2c5c82d6869ab6_icgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_a49be7df965b3acf68e2c5c82d6869ab6_icgraph" alt=""/></div>
</div>

</div>
</div>
<a id="a6810d0fa478aa8204d73d9fc5d026c64" name="a6810d0fa478aa8204d73d9fc5d026c64"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6810d0fa478aa8204d73d9fc5d026c64">&#9670;&nbsp;</a></span>SendChar_ToUART()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void SendChar_ToUART </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>ch</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Routine to send a char. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">ch</td><td>A character data writes to debug port</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Send value from UART debug port</dd></dl>
<p>Send a target char to UART debug port . </p>

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00261">261</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>
<div class="dynheader">
Here is the caller graph for this function:</div>
<div class="dyncontent">
<div class="center"><img src="../../d3/d3d/retarget_8c_a6810d0fa478aa8204d73d9fc5d026c64_icgraph.png" border="0" usemap="#ad3/d3d/retarget_8c_a6810d0fa478aa8204d73d9fc5d026c64_icgraph" alt=""/></div>
</div>

</div>
</div>
<a id="a0a9d8f093940fa3017cf1d9337ce5f25" name="a0a9d8f093940fa3017cf1d9337ce5f25"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0a9d8f093940fa3017cf1d9337ce5f25">&#9670;&nbsp;</a></span>SH_Return()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t SH_Return </td>
          <td>(</td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>n32In_R0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t&#160;</td>
          <td class="paramname"><em>n32In_R1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t *&#160;</td>
          <td class="paramname"><em>pn32Out_R0</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00175">175</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<h2 class="groupheader">Variable Documentation</h2>
<a id="abb2a819d3c88269eba04ea62d759bef5" name="abb2a819d3c88269eba04ea62d759bef5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abb2a819d3c88269eba04ea62d759bef5">&#9670;&nbsp;</a></span>__stdin</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">FILE __stdin</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00058">58</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="ac1f65ebf7d6f28fb49530ee0095306cb" name="ac1f65ebf7d6f28fb49530ee0095306cb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac1f65ebf7d6f28fb49530ee0095306cb">&#9670;&nbsp;</a></span>__stdout</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">FILE __stdout</td>
        </tr>
      </table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00057">57</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
<a id="af1f65f8ccc2d14501465115086e9c761" name="af1f65f8ccc2d14501465115086e9c761"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af1f65f8ccc2d14501465115086e9c761">&#9670;&nbsp;</a></span>g_ICE_Conneced</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="../../d5/d32/semihosting_8h.html#a8e2aaf30f82842a5290bcfe6f6848dc3">volatile</a> int32_t g_ICE_Conneced = 1</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../d3/d3d/retarget_8c_source.html#l00093">93</a> of file <a class="el" href="../../d3/d3d/retarget_8c_source.html">retarget.c</a>.</p>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 18 2024 12:20:31 for NANO102/112 BSP by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
